#include "MeshLoader.h"

std::vector<Node>& MeshLoader::GetNodes() {
	return nodes;
}

std::vector<FiniteElement>& MeshLoader::GetFE() {
	return finiteElements;
}

std::vector<BoundaryFiniteElement>& MeshLoader::GetBFE() {
	return boundaryFiniteElements;
}

std::vector<FiniteElement> MeshLoader::findFE(size_t ID1, size_t ID2, size_t ID3) {
    if (ID1 == ID2 || ID2 == ID3 || ID3 == ID1) {
        //////////
    }
    std::vector<FiniteElement> res;
    auto iter = finiteElements.begin();
    auto end = finiteElements.end();
    while (iter != end) {
        iter = std::find_if(iter, end, [ID1, ID2, ID3](FiniteElement el) {
            return std::find(el.materials.begin(), el.materials.end(), ID1) != el.materials.end()
                && std::find(el.materials.begin(), el.materials.end(), ID2) != el.materials.end()
                && std::find(el.materials.begin(), el.materials.end(), ID3) != el.materials.end(); });
        if (iter != end) {
            res.push_back(*iter);
            ++iter;
        }
    }
    if (res.begin() == res.end()) {
        ////////////
    }
    return res;
}

